#include "../bayos.h"
#include <stdio.h>

/* wiFij*/
#define cb 0xffff
/* OiFij*/
#define cc 0x0000

#define INSETS_LEFT   6
#define INSETS_TOP    22
#define INSETS_BOTTOM 6
#define INSETS_RIGHT  6

/* `Jnʒu */
int    Console::cx      = INSETS_LEFT;
int    Console::cy      = INSETS_TOP;
int    Console::cw      = FONT_W * 58 + INSETS_LEFT + INSETS_RIGHT;
int    Console::ch      = FONT_H * 17 + INSETS_TOP  + INSETS_BOTTOM;
word*  Console::vram    = NULL;
char*  Console::cmd_buf = NULL;
char*  Console::prt_buf = NULL;
Sheet* Console::sheet   = NULL;

/*  */
void Console::init() {
    /* R}hobt@[ */
    cmd_buf = new char[128];

    /* printfpobt@[ */
    prt_buf = new char[128];

    /* ~ */
    sheet = SheetCtl::allocate();
    SheetCtl::setbuf(sheet, (word *) malloc (cw * ch * sizeof(short)), cw, ch, -1);
    sheet->vx0 = (SheetCtl::ctl->xsize - cw) / 2;
    sheet->vy0 = (SheetCtl::ctl->ysize - ch) / 2;
    vram       = sheet->buffer;

    /* g`悷 */
    SheetCtl::drawFrame(sheet, "console");

    /* R\[̈wiFœhԂ */
    SheetCtl::fillRect(
        sheet,
        INSETS_LEFT,
        INSETS_TOP,
        cw - INSETS_LEFT - INSETS_RIGHT,
        ch - INSETS_TOP  - INSETS_BOTTOM,
        cb
    );

    /* ~Xgɒǉ */
    SheetCtl::updown(sheet, 1);

    putString("> "); /* vvg`*/
    drawCarret();    /* Lbg` */
}

/* `JnʒuύX */
void Console::locate(int x, int y) {
    cx = x;
    cy = y;
    if (cx >= cw - INSETS_RIGHT) {
        cy += FONT_H;
        cx = INSETS_LEFT;
    }
    if (cy >= ch - INSETS_BOTTOM) {
        cy = ch - INSETS_BOTTOM - FONT_H;
        cx = INSETS_LEFT;

        /* 1sXN[ */
        memcpy(
            &vram[cw * INSETS_TOP],
            &vram[cw * (INSETS_TOP + FONT_H)],
            cw * (ch - 28 - FONT_H) * sizeof(short)
        );

        /* XN[̍ŏIswiFœhԂ */
        SheetCtl::fillRect(
            sheet,
            INSETS_LEFT,
            ch - INSETS_BOTTOM - FONT_H,
            cw - INSETS_LEFT - INSETS_RIGHT,
            FONT_H,
            cb
        );
        SheetCtl::refresh(sheet, 0, 0, cw, ch);
    }
}

/* R}h͂ */
void Console::parseCommand() {
    /* help, ? */
    if (strncmp(cmd_buf, "help", 4) == 0 || strncmp(cmd_buf, "?", 1) == 0) {
        putString("CUI ݿ  \n");
        putString("  help/?    - \n");
        putString("  ls/dir    - ̧  ˮ\n");
        putString("  cat/type  - ̧ Ųֳ ˮ\n");
        putString("  date/time - ݻ޲ ޺ ˮ\n");
        putString("  uname/ver - ްޮ ˮ\n");
        putString("  clear/cls -  ر\n");
        putString("  ps        - ۾  ˮ\n");
        putString("  mem       - ذ ֳخ ˮ\n");
    }

    /* ls, dir */
    else if (strncmp(cmd_buf, "ls", 2) == 0 || strncmp(cmd_buf, "dir", 3) == 0) {
        List<FileEntry*>* list = File::list();
        int I = list->size();
        int total_size = 0;
        for (int i = 0; i < I; i++) {
            FileEntry* info = list->get(i);
            printf("%8d %13s\n", info->size, info->name);
            total_size += info->size;
            //delete(info);
        }
        //delete(list);
        printf("    %3d ̧ %8d ޲\n", I, total_size);
    }

    /* cat, type */
    else if (strncmp(cmd_buf, "cat ", 4) == 0 || strncmp(cmd_buf, "type ", 5) == 0) {
        char* filename;
        if (strncmp(cmd_buf, "cat ", 4) == 0) {
            filename = &cmd_buf[4];
        } else {
            filename = &cmd_buf[5];
        }
        if (strlen(filename) > 0) {
            FileEntry* entry = File::load(filename);
            dword read_size  = entry->size;
            if (read_size > 0) {
                for (int i = 0; i < (int) read_size; i++) {
                    if (entry->data[i] == '\r') {
                        // do nothing
                    } else {
                        putChar(entry->data[i]);
                    }
                }
            }
            putChar('\n');
            //delete(entry);
        }
    }

    /* date, time */
    else if (strncmp(cmd_buf, "date", 4) == 0 || strncmp(cmd_buf, "time", 4) == 0) {
        const char* day [] = { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
                             };
        const char* ampm[] = { "AM", "PM"
                             };

        RTC::init(); /* A^CNbN̏ */

        /* cF[̌ */
        int day_of_week = (
                              RTC::year +
                              int(RTC::year/4) -
                              int(RTC::year/100) +
                              int(RTC::year/400) +
                              int((13 * RTC::month + 8)/5) +
                              RTC::day
                          ) % 7;

        printf("%04d/%02d/%02d (%s) %s %02d:%02d:%02d\n",
               RTC::year,
               RTC::month,
               RTC::day,
               day[day_of_week % 7],
               ampm[RTC::hour / 12],
               RTC::hour % 12,
               RTC::minutes, RTC::second
              );
    }

    /* uname, ver */
    else if (strncmp(cmd_buf, "uname", 5) == 0 || strncmp(cmd_buf, "ver", 3) == 0) {
        printf("%s\n", BAYOS_VERSION);
    }

    /* clear, cls */
    else if (strncmp(cmd_buf, "clear", 5) == 0 || strncmp(cmd_buf, "cls", 3) == 0) {
        locate(INSETS_LEFT, INSETS_TOP);
        SheetCtl::fillRect(
            sheet,
            INSETS_LEFT,
            INSETS_TOP,
            cw - INSETS_LEFT - INSETS_RIGHT,
            ch - INSETS_TOP  - INSETS_BOTTOM,
            cb
        );
        SheetCtl::refresh(sheet, 0, 0, cw, ch);
        putString("> ");
        return;
    }

    /* ps */
    else if (strncmp(cmd_buf, "ps", 2) == 0) {
        putString("[tid]  [eip]    [esp]    [name]\n");
        for (int i = 0; i < Scheduler::runq->size(); i++) {
            Task* task = Scheduler::runq->get(i);
            printf("%05d %08x %08x %s\n",
                   task->selector,
                   task->tss.eip,
                   task->tss.esp,
                   task->name
                  );
        }
    }

    /* mem */
    else if (strncmp(cmd_buf, "mem", 3) == 0) {
        printf(" : %8d ޲\n", g_km.getTotalSize());
        printf("     : %8d ޲\n", g_km.getFreeSize());
        printf("ֳл : %8d ޲\n", (g_km.getTotalSize() - g_km.getFreeSize()));
    }

    /* OAvs */
    else {
        /* AvstO */
        bool do_exec = false;

        FileEntry* entry = File::load(cmd_buf);
        if (entry != NULL &&
            entry->size >= 36 && 
            strncmp((char *) (entry->data + 4), "Hari", 4) == 0 && 
            *(entry->data) == 0x00)
        {
            do_exec = true;
        } else {
            strcat(cmd_buf, ".hrb");
            entry = File::load(cmd_buf);
            if (entry != NULL &&
                entry->size >= 36 && 
                strncmp((char *) (entry->data + 4), "Hari", 4) == 0 && 
                *(entry->data) == 0x00)
            {
                do_exec = true;
            }
        }
        if (do_exec == true) {
            Task* exec = Scheduler::allocateTask((int) &task_exec, cmd_buf);
            Message::send(exec->id, Message::create(0, 0, 0, 0, strlen(cmd_buf) + 1, (byte *) cmd_buf));
            Scheduler::runq->add(exec);
        } else {
            Console::printf("%s: ޴װ(A)!!!\n", cmd_buf);
        }
    }

    /* ͂𑣂 */
    putString("> ");
}

/* R}hobt@[ɕ߂Ăʂɕ */
void Console::putKey(byte c) {
    /* ^u̓Xy[Xɕϊ悤 */
    if (c == '\t') {
        c = ' ';
    }

    /* s */
    if (c == '\n') {
        restoreChar();
        locate(INSETS_LEFT, cy + FONT_H);
        parseCommand();
        memset(cmd_buf, '\0', 128);
        drawCarret();
        return;
    }

    /* obNXy[X*/
    if (c == '\b' && strlen(cmd_buf) > 0) {
        cmd_buf[strlen(cmd_buf) - 1] = '\0';
        cx -= FONT_W;
    }

    /* pp */
    else if (0x20 <= c && c < 0x7f) {
        cmd_buf[strlen(cmd_buf)] = c;
    }

    restoreChar();
    putChar(c);
    drawCarret();
}

/* 1̔wi𕜌 */
void Console::restoreChar() {
    for (int y = 0; y < FONT_H; y++) {
        for (int x = 0; x < FONT_W * 2; x++) {
            putPixel(cx + x, cy + y, cb);
        }
    }

    /* ĕ` */
    SheetCtl::refresh(
        sheet,
        cx,
        cy,
        cx + (FONT_W * 2) + 1,
        cy + FONT_H + 1
    );
}

/* ʂɃLbg */
void Console::drawCarret() {
    for (int x = 0; x < FONT_W; x++) {
        putPixel(cx + x, cy + FONT_H - 2, cc);
        putPixel(cx + x, cy + FONT_H - 1, cc);
    }

    /* ĕ` */
    SheetCtl::refresh(
        sheet,
        cx,
        cy + FONT_H - 2,
        cx + FONT_W + 1,
        cy + FONT_H + 1
    );
}

/* ʂɓ_ł */
void Console::putPixel(int x, int y, word color) {
    if (x < 0 || y < 0 || x >= cw || y >= ch) return;
    vram[y * cw + x] = color;
}

/* ʂɕ */
void Console::putChar(byte c) {
    int pos = 0;

    /* s */
    if (c == '\n') {
        locate(INSETS_LEFT, cy + FONT_H);
        return;
    }

    /* ^u */
    else if (c == '\t') {
        putChar(' ');
        putChar(' ');
        putChar(' ');
        putChar(' ');
        return;
    }

    /* pp */
    else if (0x20 <= c && c < 0x7f) {
        pos = c - 0x20;
    }

#if 1
    /* pJ^Ji */
    else if (0xA1 <= c && c <= 0xdf) {
        pos = c - 0xa1 + 95;
    }

    /* ȊO̕ */
    else {
        return;
    }

    int cnt = 2;
    int bit = 1;

    for (int y = 0; y < FONT_H; y++) {
        for (int x = 0; x < FONT_W; x++) {
            if ((SheetCtl::font_hankaku[pos * 11 + cnt] & bit) != 0) {
                putPixel(cx + x, cy + y, cc);
            }
            bit <<= 1;
            if (bit == 256) {
                cnt++;
                bit = 1;
            }
        }
    }
#endif
#if 0
    /* ȊO̕ */
    else {
        return;
    }

    int x, y;
    for (y = 0; y < FONT_H; y++) {
        for (x = 0; x < FONT_W; x++) {
            if ((SheetCtl::font_latin1[pos * 16 + y] >> (7 - x)) & 0x1) {
                putPixel(cx + x, cy + y, cc);
            }
        }
    }
#endif

    /* ĕ` */
    SheetCtl::refresh(
        sheet,
        cx,
        cy,
        cx + FONT_W + 1,
        cy + FONT_H + 1
    );

    locate(cx + FONT_W, cy);
}

/* ʂɕ */
void Console::putString(const char* str) {
    while (*str != '\0') {
        putChar(*str & 0xff);
        str++;
    }
}

/* ʂɏꂽ */
void Console::printf(const char* format, ...) {
    int buf_size = 128;
    memset(prt_buf, 0, buf_size);
    va_list args;
    va_start(args, format);
    int result = vsprintf(prt_buf, format, args);
    va_end(args);
    if (result > buf_size) {
        prt_buf[buf_size - 1] = 0;
    }
    putString(prt_buf);
}
